commit e85195c9d33ef5e80352ea181b13414c42697811
Author: freddy77 <freddy77>
Date:   Thu Oct 16 11:28:06 2008 +0000

    move column_text_sqlgetdatapos logic to odbc_tds2sql

diff --git a/ChangeLog b/ChangeLog
index dd7787d..610e575 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Thu Oct 16 13:26:27 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/convert_tds2sql.c src/odbc/odbc.c:
+	* src/odbc/odbc_util.c:
+	- move column_text_sqlgetdatapos logic to odbc_tds2sql
+
 Wed Oct 15 16:51:05 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/utf8_2.c: error message more verbose
 
@@ -688,4 +693,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2618 2008/10/15 14:53:00 freddy77 Exp $
+$Id: ChangeLog,v 1.2619 2008/10/16 11:28:06 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index 28f100c..f6a7f8d 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.110 2008/09/18 08:51:21 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.111 2008/10/16 11:28:07 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -439,7 +439,7 @@ int odbc_get_dsn_info(const char *DSN, TDSCONNECTION * connection);
 /*
  * convert_tds2sql.c
  */
-TDS_INT odbc_tds2sql(TDS_STMT * stmt, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen, const struct _drecord *drec_ixd);
+TDS_INT odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen, const struct _drecord *drec_ixd);
 
 /*
  * descriptor.c
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 2c4e218..a717f88 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -39,10 +39,10 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.53 2008/09/18 08:51:21 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.54 2008/10/16 11:28:07 freddy77 Exp $");
 
 TDS_INT
-odbc_tds2sql(TDS_STMT * stmt, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen,
+odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen,
 	     const struct _drecord *drec_ixd)
 {
 	TDS_INT nDestSybType;
@@ -59,6 +59,7 @@ odbc_tds2sql(TDS_STMT * stmt, int srctype, TDS_CHAR * src, TDS_UINT srclen, int
 
 	int ret = TDS_CONVERT_FAIL;
 	int i, cplen;
+	int binary_conversion = 0;
 
 	tdsdump_log(TDS_DBG_FUNC, "odbc_tds2sql: src is %d dest = %d\n", srctype, desttype);
 
@@ -91,6 +92,8 @@ odbc_tds2sql(TDS_STMT * stmt, int srctype, TDS_CHAR * src, TDS_UINT srclen, int
 				assert(cplen >= 0);
 				/* do not NULL terminate binary buffer */
 				memcpy(dest, src, cplen);
+				if (curcol)
+					curcol->column_text_sqlgetdatapos += cplen;
 			} else {
 				/* if destlen == 0 we return only length */
 				if (destlen != 0) {
@@ -110,6 +113,18 @@ odbc_tds2sql(TDS_STMT * stmt, int srctype, TDS_CHAR * src, TDS_UINT srclen, int
 	}
 
 	if (desttype == SQL_C_CHAR) {
+		switch (srctype) {
+		case SYBLONGBINARY:
+		case SYBBINARY:
+		case SYBVARBINARY:
+		case SYBIMAGE:
+		case XSYBBINARY:
+		case XSYBVARBINARY:
+			binary_conversion = 1;
+			if (destlen && !(destlen % 2))
+				--destlen;
+		}
+
 		nDestSybType = TDS_CONVERT_CHAR;
 		ores.cc.len = destlen >= 0 ? destlen : 0;
 		ores.cc.c = dest;
@@ -148,6 +163,8 @@ odbc_tds2sql(TDS_STMT * stmt, int srctype, TDS_CHAR * src, TDS_UINT srclen, int
 			 * odbc always terminate but do not overwrite 
 			 * destination buffer more than needed
 			 */
+			if (curcol)
+				curcol->column_text_sqlgetdatapos += binary_conversion ? cplen / 2 : cplen;
 			dest[cplen] = 0;
 		} else {
 			/* if destlen == 0 we return only length */
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index b7e7b85..62a610c 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.498 2008/09/18 08:51:21 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.499 2008/10/16 11:28:07 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -3667,7 +3667,7 @@ _SQLFetch(TDS_STMT * stmt, SQLSMALLINT FetchOrientation, SQLLEN FetchOffset)
 				} else {
 					data_ptr += odbc_get_octet_len(c_type, drec_ard) * curr_row;
 				}
-				len = odbc_tds2sql(stmt, tds_get_conversion_type(colinfo->column_type, colinfo->column_size),
+				len = odbc_tds2sql(stmt, colinfo, tds_get_conversion_type(colinfo->column_type, colinfo->column_size),
 						      src, srclen, c_type, data_ptr, drec_ard->sql_desc_octet_length, drec_ard);
 				if (len < 0) {
 					row_status = SQL_ROW_ERROR;
@@ -4657,9 +4657,6 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 	SQLLEN dummy_cb;
 	int nSybType;
 
-	TDS_INT converted_column_cur_size;
-	int extra_bytes = 0;
-
 	INIT_HSTMT;
 
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetData(%p, %u, %d, %p, %d, %p)\n", 
@@ -4696,7 +4693,6 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 		ODBC_RETURN(stmt, SQL_ERROR);
 	}
 	colinfo = tds->current_results->columns[icol - 1];
-	converted_column_cur_size = colinfo->column_cur_size;
 
 	if (colinfo->column_cur_size < 0) {
 		*pcbValue = SQL_NULL_DATA;
@@ -4715,79 +4711,17 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 
 		src = (TDS_CHAR *) colinfo->column_data;
 		if (is_variable_type(colinfo->column_type)) {
-			int nread = 0;
-			
 			/* 2003-8-29 check for an old bug -- freddy77 */
 			assert(colinfo->column_text_sqlgetdatapos >= 0);
 			if (is_blob_type(colinfo->column_type))
 				src = ((TDSBLOB *) src)->textvalue;
 
-			if (fCType == SQL_C_CHAR) {
-				TDS_CHAR buf[3];
-				SQLLEN len;
-
-				switch (nSybType) {
-				case SYBLONGBINARY:
-				case SYBBINARY:
-				case SYBVARBINARY:
-				case SYBIMAGE:
-				case XSYBBINARY:
-				case XSYBVARBINARY:
-				case TDS_CONVERT_BINARY:
-					if (colinfo->column_text_sqlgetdatapos % 2) {
-						nread = (colinfo->column_text_sqlgetdatapos - 1) / 2;
-						if (nread >= colinfo->column_cur_size)
-							ODBC_RETURN(stmt, SQL_NO_DATA);
-						
-						if (cbValueMax > 2) {
-							len = odbc_tds2sql(stmt, nSybType, src + nread, 1, fCType, buf, sizeof(buf), NULL);
-							if (len < 2)
-								ODBC_RETURN(stmt, SQL_ERROR);
-							*(TDS_CHAR *) rgbValue = buf[1];
-							*((TDS_CHAR *) rgbValue + 1) = 0;
-						
-							rgbValue++;
-							cbValueMax--;
-						
-							extra_bytes = 1;
-							nread++;
-
-							if (nread >= colinfo->column_cur_size)
-								ODBC_RETURN_(stmt);
-						} else {
-							if (cbValueMax) 
-								*(TDS_CHAR *) rgbValue = 0;
-							odbc_errs_add(&stmt->errs, "01004", "String data, right truncated");
-							ODBC_RETURN(stmt, SQL_SUCCESS_WITH_INFO);
-						}
-					} else {
-						nread = colinfo->column_text_sqlgetdatapos / 2;
-						
-						if (colinfo->column_text_sqlgetdatapos > 0
-						    && nread >= colinfo->column_cur_size)
-							ODBC_RETURN(stmt, SQL_NO_DATA);
-					}
-					
-					src += nread;
-					srclen = colinfo->column_cur_size - nread;
-					converted_column_cur_size *= 2;
-					break;
-				default:
-					if (colinfo->column_text_sqlgetdatapos > 0
-					&&  colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
-						ODBC_RETURN(stmt, SQL_NO_DATA);
-						
-					src += colinfo->column_text_sqlgetdatapos;
-					srclen = colinfo->column_cur_size - colinfo->column_text_sqlgetdatapos;
-				}
-			} else {
-				if (colinfo->column_text_sqlgetdatapos > 0
-				&&  colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
-					ODBC_RETURN(stmt, SQL_NO_DATA);
+			if (colinfo->column_text_sqlgetdatapos > 0
+			&&  colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
+				ODBC_RETURN(stmt, SQL_NO_DATA);
 
-				src += colinfo->column_text_sqlgetdatapos;
-				srclen = colinfo->column_cur_size - colinfo->column_text_sqlgetdatapos;
-			}
+			src += colinfo->column_text_sqlgetdatapos;
+			srclen = colinfo->column_cur_size - colinfo->column_text_sqlgetdatapos;
 		} else {
 			if (colinfo->column_text_sqlgetdatapos > 0
 			&&  colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
@@ -4796,30 +4730,16 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 			srclen = colinfo->column_cur_size;
 		}
 
-		*pcbValue = odbc_tds2sql(stmt, nSybType, src, srclen, fCType, (TDS_CHAR *) rgbValue, cbValueMax, NULL);
+		*pcbValue = odbc_tds2sql(stmt, colinfo, nSybType, src, srclen, fCType, (TDS_CHAR *) rgbValue, cbValueMax, NULL);
 		if (*pcbValue < 0)
 			ODBC_RETURN(stmt, SQL_ERROR);
 		
-		if (extra_bytes) {
-			colinfo->column_text_sqlgetdatapos += extra_bytes;
-			*pcbValue += extra_bytes;
-		}
-		
 		if (is_variable_type(colinfo->column_type) && (fCType == SQL_C_CHAR || fCType == SQL_C_BINARY)) {
-			/* calculate how many bytes were read */
-			int remaining = cbValueMax;
-
-			/* FIXME test on destination char ??? */
-			if (stmt->dbc->env->attr.output_nts != SQL_FALSE && fCType == SQL_C_CHAR && remaining > 0)
-				--remaining;
-			if (remaining > *pcbValue)
-				remaining = *pcbValue;
-			colinfo->column_text_sqlgetdatapos += remaining;
 			/* avoid infinite SQL_SUCCESS on empty strings */
 			if (colinfo->column_text_sqlgetdatapos == 0 && cbValueMax > 0)
 				++colinfo->column_text_sqlgetdatapos;
-			
-			if (colinfo->column_text_sqlgetdatapos < converted_column_cur_size) {	/* not all read ?? */
+
+			if (colinfo->column_text_sqlgetdatapos < colinfo->column_cur_size) {	/* not all read ?? */
 				odbc_errs_add(&stmt->errs, "01004", "String data, right truncated");
 				ODBC_RETURN(stmt, SQL_SUCCESS_WITH_INFO);
 			}
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index f13098b..ef8b8dc 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -39,7 +39,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.103 2008/09/18 08:51:22 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.104 2008/10/16 11:28:07 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -138,7 +138,7 @@ odbc_set_return_status(struct _hstmt *stmt, unsigned int n_row)
 		}
 #define LEN(ptr) *((SQLLEN*)(((char*)(ptr)) + len_offset))
 
-		len = odbc_tds2sql(stmt, SYBINT4, (TDS_CHAR *) & tds->ret_status, sizeof(TDS_INT),
+		len = odbc_tds2sql(stmt, NULL, SYBINT4, (TDS_CHAR *) & tds->ret_status, sizeof(TDS_INT),
 				   drec->sql_desc_concise_type, (void *) data_ptr, drec->sql_desc_octet_length, NULL);
 		if (len < 0)
 			return /* SQL_ERROR */ ;
@@ -219,7 +219,7 @@ odbc_set_return_params(struct _hstmt *stmt, unsigned int n_row)
 		 * TODO why IPD ?? perhaps SQLBindParameter it's not correct ??
 		 * Or tests are wrong ??
 		 */
-		len = odbc_tds2sql(stmt, tds_get_conversion_type(colinfo->column_type, colinfo->column_size), src, srclen,
+		len = odbc_tds2sql(stmt, colinfo, tds_get_conversion_type(colinfo->on_server.column_type, colinfo->on_server.column_size), src, srclen,
 				   c_type, (void *) data_ptr, drec_apd->sql_desc_octet_length, drec_ipd);
 		if (len < 0)
 			return /* SQL_ERROR */ ;

